%define debug_package %{nil}
%define _unpackaged_files_terminate_build 0
%define __os_install_post       /bin/true
%define distribution %(/usr/lib/rpm/redhat/dist.sh --distnum)

Summary: XROOTD gridftp DSI plugin
Name: xrootd-dsi
Version: 5.5.1
Release: 1%{dist}
Prefix: /usr
License: none
Group: Applications/File
Source: %{name}-%{version}-1.tar.gz
BuildRoot: %{_tmppath}/%{name}-root

Requires: globus-gridftp-server
Requires: globus-gridftp-server-control

Requires: xrootd-client >= 5.5.1
Requires: globus-gridftp-server-progs

BuildRequires: redhat-rpm-config , git
BuildRequires: globus-gridftp-server-devel
#BuildRequires: xrootd-client >= 3.3.0
BuildRequires: xrootd-client-devel >= 5.5.1
BuildRequires: cmake
BuildRequires: xrootd-devel >= 5.5.1
BuildRequires: xrootd-server-devel >= 5.5.1
BuildRequires: perl
BuildRequires: globus-gridftp-server-progs
BuildRequires: yum-utils

%description
XROOTD gridftp DSI plugin

%prep
%setup -n %{name}-%{version}-1

%build
test -e $RPM_BUILD_ROOT && rm -r $RPM_BUILD_ROOT

mkdir -p build
cd build
cmake ../ -DRELEASE=1 -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_MODULE_PATH=cmake
# we force the deletion of the globus hack header to avoid any problems with left overs and multiple builds
# this forces the rebuild of the header with currently installed versions of globus packages
rm -f ../src/globus_gfs_internal_hack.h

%install
cd build
%{__make} install DESTDIR=$RPM_BUILD_ROOT
echo "Installed!"

%clean
rm -rf $RPM_BUILD_ROOT 

%files
%defattr(-,root,root,-)
%{_libdir}/*.so*
%_sysconfdir/init.d/xrootd-gridftp
%config %_sysconfdir/sysconfig/xrootd-gridftp-server


%doc

%post
/sbin/chkconfig --add xrootd-gridftp
echo Starting conditional XROOTD grid-ftp services
/sbin/service xrootd-gridftp condrestart > /dev/null 2>&1 || :
%preun 
if [ $1 = 0 ]; then
        echo Stopping XROOTD grid-ftp services
        /sbin/service xrootd-gridftp stop > /dev/null 2>&1 
        /sbin/chkconfig --del xrootd-gridftp
fi

%changelog
* Fri Dec 08 2022 <mbatalha@cern.ch> - dsi 5.1.1-1
- change release of dsi to match xrootd which is built with
- built with 5.1.1
* Thu Dec 05 2019 <rvalverd@cern.ch> - dsi 0.3.11-1
- improve sysV service script
* Fri Apr 12 2019 <andrea.manzi@cern.ch> - dsi 0.3.10-1
- disable read ahead
* Fri Jul 21 2017 <andrea.manzi@cern.ch> - dsi 0.3.9-1
- report error on xrootd file handle close
* Thu Jul 14 2017 <andrea.manzi@cern.ch> - dsi 0.3.8-2
- rebuild for wrong tag created 
* Thu Jul 13 2017 <andrea.manzi@cern.ch> - dsi 0.3.8-1
- add workaround to fix permission on stat
* Fri Oct 16 2015 <geoffray.adde@cern.ch> - dsi 0.3.7-1
- intercept transfer cancelation to cleanup the plugin before it's deactivated
* Wed Oct 14 2015 <geoffray.adde@cern.ch> - dsi 0.3.6-1
- make the XRootD client fork-safe by enabling the proper en variable in the init.d script
* Wed Oct 14 2015 <geoffray.adde@cern.ch> - dsi 0.3.5-1
- turn the only global object to a dynamically allocated object
* Tue Oct 6 2015 <geoffray.adde@cern.ch> - dsi 0.3.4-1
- remove debug logging on read/write registering 
* Thu Sep 3 2015 <geoffray.adde@cern.ch> - dsi 0.3.3-6
- remove warning in init script
- remove legacy globus_gridftp_server_xrootd_gcc64pthr.so legacy shared object
* Tue Aug 25 2015 <geoffray.adde@cern.ch> - dsi 0.3.3-4
- fix the build system to remove dependency on strict versions of globus gridftp rpms
* Fri Aug 21 2015 <geoffray.adde@cern.ch> - dsi 0.3.3-3
- modify the build system to generate different rpm version and release name if simple commit or tagged version
* Wed Feb 12 2014 <geoffray.adde@cern.ch> - dsi 0.3.3-2
- fix a possible crash when XROOTD_VMP is not properly formated
* Fri Nov 19 2013 <geoffray.adde@cern.ch> - dsi 0.3.3-1
- add extra support for multiple "gridftp mounting points" -> syntax of XROOTD_VMP changed!
- fix the xrootd id change caused by the check when the dsi plugin is getting initialized
* Fri Oct 25 2013 <geoffray.adde@cern.ch> - dsi 0.3.2-1
- add extra checkings on plugin init to see if XROOTD_VMP is properly set and add error reporting
- fix the the preuninstall script in the rpm
- mark config files as such in the rpm
* Thu Oct 17 2013 <geoffray.adde@cern.ch> - dsi 0.3.1-1
- add protection for memory unallocation against unallocated memory while an unsucessful authentication happens
- fix a bug related to XROOTD_DSI_EOS* environment variables poetentialy not taken into account
* Tue Feb 05 2013 <geoffray.adde@cern.ch> - dsi 0.3.0-1 
- changing name to XRootD plugin (eos features are now optional and can be configured in /etc/sysconfig/xrootd-gridftp-server)
- moving to CMake build
- moving to xrootd 3.3.0 ( move from XrdPosix to XrdCl, XrdCl being part of the xrootd package)
